/***************************************************************************
 *   Copyright (C) 2004 by Konstantin Sobolev                              *
 *   konstantin.sobolev@gmail.com                                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef KENCODEDLOGSOURCE_H
#define KENCODEDLOGSOURCE_H

#include <klogsource.h>

/**
@author Konstantin Sobolev
*/
class KEncodedLogSource : public KLogSource
{
Q_OBJECT
public:
    KEncodedLogSource();
    
    KEncodedLogSource(QString name, QColor textColor, bool bold, bool underline, bool italic);

    ~KEncodedLogSource();

    virtual void insertMenuItems(QPopupMenu* popup);
    virtual void readConfig(KConfig* config);
    virtual void writeConfig(KConfig* config);

protected:
    QString encoding;
    QString decode(const char*, int);
protected slots:
    void encodingsMenuActivated(int);    
};

#endif
