/***************************************************************************
 *   Copyright (C) 2004 by Konstantin Sobolev                              *
 *   konstantin.sobolev@gmail.com                                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef FILTERSCOLLECTION_H
#define FILTERSCOLLECTION_H

#include <kconfig.h>
#include <qwidget.h>
#include <qstring.h>
#include <qptrlist.h>
#include <qrect.h>
#include "kfilter.h"

/**
@author Konstantin Sobolev
*/
class KFiltersCollection{
public:
    KFiltersCollection();
    virtual ~KFiltersCollection();
    
    virtual bool passes(QString);
    virtual QString alert(QString);
    virtual void writeConfig(KConfig*, QString);
    virtual void readConfig(KConfig*, QString);
    virtual void edit(QWidget*);
protected:
    QPtrList<KFilter> filters;
    QRect editorGeometry;
};

#endif
