/*
 * Copyright (C) 2003 Konstantin Sobolev <konstantin.sobolev@gmail.com>
 */

#ifndef _KLOGVIEW_H_
#define _KLOGVIEW_H_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <kapplication.h>
#include <kaboutdata.h>
#include <kconfig.h>
#include <klocale.h>
#include <kpopupmenu.h>
#include <kmainwindow.h>
#include <kdockwidget.h>
#include <qptrlist.h>
#include <qwidget.h>
#include <qevent.h>

#include "klogtray.h"
#include "klogwidget.h"
#include "kfilelogsource.h"

class KLogWidget;
class KLogTray;

/**
 * @short Application Main Window
 * @author Konstantin Sobolev <konstantin.sobolev@gmail.com>
 * @version 0.1
 */
class KLogView : public KDockMainWindow {
    Q_OBJECT
public:
    /**
     * Default Constructor
     */
    KLogView(bool startMinimized=FALSE);


    /**
     * Default Destructor
     */
    virtual ~KLogView();
    
    KAboutData* getAboutData() {return aboutData;}
    void setAboutData(KAboutData* aboutData) {this->aboutData = aboutData;}
protected:
    void mousePressEvent(QMouseEvent *);
    void writeConfig();
    void readConfig();
    virtual void closeEvent (QCloseEvent *);
private:
    KAboutData* aboutData;
    QPtrList<KLogWidget> logWindows;
    QPixmap* smallIcon;
    KPopupMenu* popup;
    bool startMinimized;

    KLogWidget* addLogWindow(QString);
public slots:
    void addLogWindow();    
private slots:
    void closeLogWindow();
    void shutDown();
};

#endif // _KLOGVIEW_H_
