/***************************************************************************
 *   Copyright (C) 2003 by Konstantin Sobolev                              *
 *   konstantin.sobolev@gmail.com                                                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#ifndef KPROCESSOUTPUTLOGSOURCE_H
#define KPROCESSOUTPUTLOGSOURCE_H

#include <kprocess.h>
#include <kencodedlogsource.h>

/**
@author Konstantin Sobolev

todo: stderr options: color | {err} prefix | both
*/
class KProcessOutputLogSource : public KEncodedLogSource {
    Q_OBJECT
    friend class KLogSource;
public:
    KProcessOutputLogSource(QString command, bool autorun=TRUE, QColor textColor = QColor("black"), bool bold=FALSE, bool underline=FALSE, bool italic=FALSE);
    ~KProcessOutputLogSource();

    virtual void writeConfig(KConfig* config);
    virtual void readConfig(KConfig* config);
    virtual void insertMenuItems(QPopupMenu* popup);

    virtual KLogSource::LogSourceType getType() {return KLogSource::Process;};
protected:
    KProcessOutputLogSource() {};
    QString command;
    KProcess process;
    bool autorun;
    void setCommand(QString command, bool start);
    void initProcess();

protected slots:
    void processExited(KProcess*);
    void receivedStdout(KProcess*, char*, int);
    void receivedStderr(KProcess*, char*, int);
    void start();
    void stop();
    void setCommand();
    void toggleAutorun();
};

#endif
