/*
 * Copyright (C) 2003 Konstantin Sobolev <konstantin.sobolev@gmail.com>
 */

#include "klogview.h"
#include "klogwidget.h"
#include "klogtray.h"
#include <kapplication.h>
#include <kcmdlineargs.h>
#include <klocale.h>

static const char description[] =
    I18N_NOOP("A KDE Log Viewer");

static const char version[] = "0.6";

static KCmdLineOptions options[] =
    {
        { "m", I18N_NOOP("Start minimized to tray."), 0},
        KCmdLineLastOption
    };

int main(int argc, char **argv) {
    KAboutData* about = new KAboutData("klogview", I18N_NOOP("klogview"), version, description,
                     KAboutData::License_GPL, "(C) 2005 Konstantin Sobolev", 0, 0, "konstantin.sobolev@gmail.com");
    about->addAuthor( "Konstantin Sobolev", 0, "konstantin.sobolev@gmail.com" );
    
    KCmdLineArgs::init(argc, argv, about);
    KCmdLineArgs::addCmdLineOptions( options );
    
    KApplication app;
    KLogView *logView = 0;

    if (app.isRestored()) {
        RESTORE(KLogView);
    } else {
        // no session.. just start up normally
        KCmdLineArgs *args = KCmdLineArgs::parsedArgs();

        logView = new KLogView(args->isSet("m"));
        logView -> setAboutData(about);
        app.setMainWidget( logView );
        logView->show();
        args->clear();
    }

    // mainWin has WDestructiveClose flag by default, so it will delete itself.
    return app.exec();
}

